/***************************************************************************
These C++ classes are copyright 1990, by William Herrera.
All those who put this code or its derivatives in a commercial product MUST
mention this copyright in their documentation for users of the products in
which this code or its derivative classes are used.  Otherwise, this code
may be freely distributed and freely used for any purpose.
***************************************************************************/

// file modem.hpp class declaration of modem class.

#ifndef MODEM_HPP
#define MODEM_HPP 1
			   
#include "serialpo.hpp"

extern const char inits[];
extern const char tonedials[];
extern const char pulsedials[];
extern const char answers[];
extern const char hangups[];
extern const char resets[];
extern const char returns[];
extern const char escapes[];
extern const char defaultcfgs[];


class modem : public SerialPort
{
protected:
	char * init;
	char * tonedial;
	char * pulsedial;
	char * answer;
	char * hangup;
	char * reset;
	char * retrn;
	char * escape;
public:
	modem(int portnum = 1, long speed = 38400, 
					parity_t p = NOPAR, int sbits = 1, 
					int dbits = 8, boolean trans = false);
	~modem();
	void ConfigureFromFile(const char * pathname = defaultcfgs);
	void Initialize();
	void Dial(char * number, boolean tone = true);
	void HangUp();
	void Answer();
	void Escape();
	void SendCommand(char * command);
	void Send(char ch);
	void Send(char * s);
	void Send(int i);
	void Send(long l);
	void Send(float f);
	void Send(double d);
};

#endif

// end of file modem.hpp
